'
' PBWin Compiler - Author Jrgen Huhn 2012 - eMail: JuHuhn@hotmail.com
'
' This Program easy creates the Windows 7 "God Mode" as a folder on the Desktop. ;)
'
#COMPILE EXE "JH_GodMode.exe"
#DIM ALL
#INCLUDE ONCE "Win32API.inc"

TYPE ShortItemId   ' = SHITEMID
    cb           AS WORD
    abID(0 TO 0) AS BYTE ' array size
END TYPE
'
TYPE ITEMIDLIST
    mkid AS ShortItemId
END TYPE

DECLARE FUNCTION SHGetSpecialFolderLocation LIB "SHELL32.DLL" ALIAS "SHGetSpecialFolderLocation" (BYVAL hwndOwner AS DWORD, BYVAL nFolder AS LONG, pidl AS ANY) AS LONG
DECLARE FUNCTION SHGetPathFromIDList LIB "SHELL32.DLL" ALIAS "SHGetPathFromIDListA" (BYVAL pidList  AS LONG  , lpBuffer AS ASCIIZ) AS LONG
DECLARE SUB CoTaskMemFree LIB "ole32.dll" ALIAS "CoTaskMemFree" (BYVAL pMem AS DWORD)
%CSIDL_DESKTOP                   = &H0000& '// <desktop>

'----======xxxxxxxxxxXXXXXXXXXX-JH_DIRExist-XXXXXXXXXXxxxxxxxxxx======----
'--------------------------------------------------------------------------
' - make sure directory exists --> Excludes files.
' Checks for the existence of a directory
' Returns %TRUE if directory exists or %FALSE otherwise.
'-------------------------------------------------------------------------
FUNCTION JH_DIRExist (BYVAL sDIR AS STRING) AS LONG
   LOCAL WD    AS WIN32_FIND_DATA
   LOCAL dwsDir AS DWORD , nReturn AS LONG
   nReturn = %FALSE
   IF LEN(sDIR) THEN
      sDIR = RTRIM$(sDIR, ANY "\")
      dwsDir = FindFirstFile (BYCOPY sDIR, WD)
      IF dwsDir <>  %INVALID_HANDLE_VALUE THEN
         FindClose dwsDir
         IF (WD.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY) = %FILE_ATTRIBUTE_DIRECTORY THEN
            nReturn = %TRUE
         END IF
      END IF
    END IF
    FUNCTION = nReturn
END FUNCTION
'----======xxxxxxxxxxXXXXXXXXXX-JH_DIRExist-XXXXXXXXXXxxxxxxxxxx======----
'
'----====xxxxxxXXXXXXXXXXXXX-GetSpecialFolder-XXXXXXXXXXXXXxxxxxx====-----
FUNCTION JH_GetSpecialFolder(BYVAL CSIDL AS DWORD) AS STRING
    LOCAL pItemIdList AS ITEMIDLIST POINTER
    LOCAL szBuffer    AS ASCIIZ * %MAX_PATH
    IF SHGetSpecialFolderLocation(BYVAL %NULL, CSIDL, pItemIdList) = 0 THEN
       IF SHGetPathFromIDList(pItemIdList, szBuffer) THEN
          szBuffer = RTRIM$(szBuffer, ANY " ")
          IF ASC(szBuffer, -1) <> 92 THEN szBuffer = szBuffer + "\"
          FUNCTION = szBuffer
       END IF
       CALL CoTaskMemFree(BYVAL pItemIdList)
    END IF
END FUNCTION
'------========xxxxxxxxXXXXXXXXXXXXX-PBMAIN-XXXXXXXXXXXXXxxxxxxxxx========------
FUNCTION PBMAIN () AS LONG
    LOCAL szdummy AS ASCIIZ * %MAX_PATH
    LOCAL strUserDesktop AS STRING

   ' szdummy = "Der Ordner GodMode wurde bereits auf dem Desktop erstellt!"
    szdummy = "The folder GodMode is already installed on the Desktop!"
    CALL JH_GetSpecialFolder(%CSIDL_DESKTOP) TO strUserDesktop
    IF LEN(strUserDesktop) THEN strUserDesktop = RTRIM$(strUserDesktop, ANY "\ ") + "\"  ELSE EXIT FUNCTION ' if executed from Compiler EXIT
    strUserDesktop = strUserDesktop + "GodMode.{ED7BA470-8E54-465E-825C-99712043E01C}"
    IF JH_DirExist(strUserDesktop) = %FALSE THEN
       szdummy = strUserDesktop
       CALL CreateDirectory(szdummy , "")
       CALL ShellExecute(BYVAL %NULL, "open", "explorer.exe", szdummy, "", %SW_SHOW)
       EXIT FUNCTION
    END IF
    MSGBOX szdummy, %MB_OK OR %MB_ICONINFORMATION OR %MB_TOPMOST OR %MB_SETFOREGROUND, EXE.NAME$
    szdummy = strUserDesktop
    CALL ShellExecute(BYVAL %NULL, "open", "explorer.exe", szdummy, "", %SW_SHOW)
END FUNCTION
'------========xxxxxxxxXXXXXXXXXXXXX-PBMAIN-XXXXXXXXXXXXXxxxxxxxxx========------
